//
//  ByteArrayPiece.h
//  HexFiend
//
//  Created by ridiculous_fish on 9/8/04.
//  Copyright 2004-2006 ridiculous_fish. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class ByteSlice;

//ByteArrayPieces form an AVL tree
//Their offsets (myRange.location) is mutable, their ByteSlice is not
@class ByteArrayPiece;

@interface ByteArrayPiece : NSObject {
    @public
    LongRange myRange;
    @private
    ByteSlice* mySlice;
    unsigned long long myRetainCount;
}

- initWithSlice:(ByteSlice*)slice offset:(unsigned long long)offset;
- (unsigned long long)offset;
- (unsigned long long)length;
- (void)setOffset:(unsigned long long)offset;
- (ByteSlice*)byteSlice;

- (LongRange*)tavl_key;

@end

@interface ByteArrayPiece (FastPath)

- (BOOL)fastPathAppendByteSlice:(ByteSlice*)slice atLocation:(unsigned long long)location;

@end
