/*
 *  HexViewTypes.h
 *  HexFiend1
 *
 *  Created by Darkshadow on 7/19/08.
 *  Copyright 2008 Night Productions. All rights reserved.
 *
 */

typedef float BCFloat;
typedef struct {
	unsigned long long location;
	unsigned long long length;
} LongRange;

static inline unsigned ll2u(unsigned long long val) { return (unsigned)val; }
static inline unsigned long ll2l(unsigned long long val) { return (unsigned long) val; }
static inline LongRange MakeLongRange(unsigned long long loc, unsigned long long len) {
	return (LongRange){loc, len};
}
static inline BOOL LongRangeEquals(LongRange a, LongRange b) {
	return a.location == b.location && a.length == b.length;
}
static inline NSString *StringFromLongRange(LongRange range) {
	return [NSString stringWithFormat:@"{%llu, %llu}", range.location, range.length];
}
static inline unsigned long long MaxLongRange(LongRange range) {
	return (range.location + range.length);
}
static inline unsigned long long llmin(unsigned long long a, unsigned long long b) {
	return (a < b) ? a : b;
}
static inline unsigned long long llmax(unsigned long long a, unsigned long long b) {
	return (a > b) ? a : b;
}
